Module ij
Package ij.process

# Class StackProcessor

java.lang.Object
ij.process.StackProcessor

public class StackProcessor extends Object
This class processes stacks.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`FILTER_MAX`
`static final int`
`FILTER_MAXLOCAL`
`static final int`
`FILTER_MEAN`
`static final int`
`FILTER_MEDIAN`
`static final int`
`FILTER_MIN`
`static final int`
`FILTER_VAR`

## Constructor Summary

Constructors
Constructor
Description
`StackProcessor(ImageStack stack)`
Constructs a StackProcessor from a stack.
`StackProcessor(ImageStack stack, ImageProcessor ip)`
Constructs a StackProcessor from a stack.

## Method Summary

Modifier and Type
Method
Description
`void`
`applyTable(int[] table)`
`void`
`copyBits(ImageStack src, int xloc, int yloc, int mode)`
`void`
`copyBits(ImageProcessor src, int xloc, int yloc, int mode)`
`ImageStack`
`crop(int x, int y, int width, int height)`
Crops the stack to the specified rectangle.
`void`
`filter3D(ImageStack out, float radx, float rady, float radz, int zmin, int zmax, int filter)`
3D filter using threads
`void`
`flipHorizontal()`
`void`
`flipVertical()`
`void`
`invert()`
`ImageStack`
`resize(int newWidth, int newHeight)`
Creates a new stack with dimensions 'newWidth' x 'newHeight'.
`ImageStack`
`resize(int newWidth, int newHeight, boolean averageWhenDownsizing)`
`ImageStack`
`rotateLeft()`
`ImageStack`
`rotateRight()`
`void`
`scale(double xScale, double yScale)`
`void`
`scale(double xScale, double yScale, double fillValue)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### FILTER_MEAN

public static final int FILTER_MEAN

See Also:
  - Constant Field Values

### FILTER_MEDIAN

public static final int FILTER_MEDIAN

See Also:
  - Constant Field Values

### FILTER_MIN

public static final int FILTER_MIN

See Also:
  - Constant Field Values

### FILTER_MAX

public static final int FILTER_MAX

See Also:
  - Constant Field Values

### FILTER_VAR

public static final int FILTER_VAR

See Also:
  - Constant Field Values

### FILTER_MAXLOCAL

public static final int FILTER_MAXLOCAL

See Also:
  - Constant Field Values

## Constructor Details

### StackProcessor

public StackProcessor(ImageStack stack)
Constructs a StackProcessor from a stack.

### StackProcessor

public StackProcessor(ImageStack stack, ImageProcessor ip)
Constructs a StackProcessor from a stack. 'ip' is the processor that will be used to process the slices. 'ip' can be null when using crop().

## Method Details

### invert

public void invert()

### flipHorizontal

public void flipHorizontal()

### flipVertical

public void flipVertical()

### applyTable

public void applyTable(int[] table)

### scale

public void scale(double xScale, double yScale)

### scale

public void scale(double xScale, double yScale, double fillValue)

### resize

public ImageStack resize(int newWidth, int newHeight)
Creates a new stack with dimensions 'newWidth' x 'newHeight'. To reduce memory requirements, the orginal stack is deleted as the new stack is created.

### resize

public ImageStack resize(int newWidth, int newHeight, boolean averageWhenDownsizing)

### crop

public ImageStack crop(int x, int y, int width, int height)
Crops the stack to the specified rectangle.

### rotateRight

public ImageStack rotateRight()

### rotateLeft

public ImageStack rotateLeft()

### copyBits

public void copyBits(ImageProcessor src, int xloc, int yloc, int mode)

### copyBits

public void copyBits(ImageStack src, int xloc, int yloc, int mode)

### filter3D

public void filter3D(ImageStack out, float radx, float rady, float radz, int zmin, int zmax, int filter)
3D filter using threads

Parameters:
  `out` -
  `radx` - Radius of mean filter in x
  `rady` - Radius of mean filter in y
  `radz` - Radius of mean filter in z
  `zmin` -
  `zmax` -
  `filter` -